import arcpy
from math import*
try:
    #parameter values
    wsp=arcpy.GetParameterAsText(0)
    outwarstwa=arcpy.GetParameterAsText(1)
    zasieg=arcpy.GetParameterAsText(2)
    oczko=arcpy.GetParameterAsText(3)
    oczko2=arcpy.GetParameter(4)
    mnoznik=arcpy.GetParameter(5)
    mnoznik1=arcpy.GetParameter(6)
    #workspace
    arcpy.env.workspace=wsp
    arcpy.env.overWriteOutput = True
    s=round(mnoznik,6)
    s1=round(mnoznik1,6)
    #creating buffers equal to the mesh of the mesh around each range
    if str(oczko)=="rod (XIII) 4,7 m":
        t=4.70
    if str(oczko)=="rod (XIV) 4,32 m":
        t=4.32
    if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
        t=0.626
    if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
        t=0.576
    if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
        t=0.313
    if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
        t=0.288
    if str(oczko)=="fathom 2,134 m":
        t=2.134
    if str(oczko)=="rope (for the rod 4,7 m x 10)":
        t=(10*4.7)
    if str(oczko)=="rope (for the rod 4,32 m x 10)":
        t=(10*4.32)
    if str(oczko)=="none":
        t=oczko2
    arcpy.Buffer_analysis(zasieg,"buf.shp",s*t)
    # creating a minimal outline of an object - range
    in_feature1="buf.shp"
    arcpy.MakeFeatureLayer_management(in_feature1,"buf_lyr.lyr")
    arcpy.MinimumBoundingGeometry_management("buf_lyr.lyr","zasieg.shp","RECTANGLE_BY_WIDTH")
    #removing the OID field from the range.shp layer table
    arcpy.DeleteField_management("zasieg.shp","OID_")
    #range to points
    arcpy.FeatureVerticesToPoints_management("zasieg.shp","zasieg_pkt.shp","ALL")
    #adding X and Y fields and coordinates to the layer
    in_features1="zasieg_pkt.shp"
    field_name1="X"
    field_name2="Y"
    arcpy.AddField_management(in_features1, field_name1, "DOUBLE",30,4)
    field_name2="Y"
    arcpy.AddField_management(in_features1, field_name2, "DOUBLE",30,4)
    in_features2="zasieg_pkt.shp"
    expression1="!SHAPE.CENTROID.X!"
    arcpy.CalculateField_management(in_features1, "X", expression1, "PYTHON_9.3")
    expression2="!SHAPE.CENTROID.Y!"
    arcpy.CalculateField_management(in_features1, "Y", expression2, "PYTHON_9.3")
    #create a dbf table from the attribute table of the layer
    arcpy.CopyRows_management("zasieg_pkt.shp","zasieg_tab.dbf")
    fc = "zasieg_tab.dbf"
    #get values from table to the grid
    where_clause='"OID" = 0'
    rows = arcpy.SearchCursor(fc,where_clause,"","X;Y","")
    for row in rows:
         x1=(row.getValue("X"))
         y1=(row.getValue("Y"))
         a=(str(row.getValue("X")))
         b=(str(row.getValue("Y")))
         c=a+" "+b
    fc = "zasieg_tab.dbf"
    where_clause='"OID" = 1'
    rows = arcpy.SearchCursor(fc,where_clause,"","X;Y","")
    for row in rows:
         x2=(row.getValue("X"))
         y2=(row.getValue("Y"))
         d=(str(row.getValue("X")))
         e=(str(row.getValue("Y")))
         f=d+" "+e
    fc = "zasieg_tab.dbf"
    where_clause='"OID" = 2'
    rows = arcpy.SearchCursor(fc,where_clause,"","X;Y","")
    for row in rows:
         x3=(row.getValue("X"))
         y3=(row.getValue("Y"))
         g=(str(row.getValue("X")))
         h=(str(row.getValue("Y")))
         k=g+" "+h
    distanceh =sqrt((x1 - x2)**2 + (y1 - y2)**2)
    distancew =sqrt((x2 - x3)**2 + (y2 - y3)**2)
    distance1=round(distanceh,0)
    distance2=round(distancew,0)
    origin_coord=c
    y_axis_coord=f
    #conditional determination of mesh size
    if str(oczko)=="rod (XIII) 4,7 m":
        cell_width=s*4.7
        cell_height=s1*4.7
    if str(oczko)=="rod (XIV) 4,32 m":
        cell_width=s*4.32
        cell_height=s1*4.32
    if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
        cell_width=s*0.626
        cell_height=s1*0.626
    if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
        cell_width=s*0.576
        cell_height=s1*0.576
    if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
        cell_width=s*0.313
        cell_height=s1*0.313
    if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
        cell_width=s*0.288
        cell_height=s1*0.288
    if str(oczko)=="fathom 2,134 m":
        cell_width=s*2.134
        cell_height=s1*2.134
    if str(oczko)=="rope (for the rod 4,7 m x 10)":
        cell_width=s*(10*4.7)
        cell_height=s1*(10*4.7)
    if str(oczko)=="rope (for the rod 4,32 m x 10)":
        cell_width=s*(10*4.32)
        cell_height=s1*(10*4.32)
    else:
        cell_width=s*t
        cell_height=s1*t
    r=(distance1/cell_height)
    c=(distance2/cell_width)
    number_rows=round(r,0)
    number_columns=round(c,0)
    corner_coord=k
    arcpy.CreateFishnet_management("net_test.shp", origin_coord, y_axis_coord, cell_width, cell_height, number_rows, number_columns, corner_coord,  "NO_LABELS", "buf.shp", "POLYGON")
    #creating a grid layer
    in_feature2="net_test.shp"
    arcpy.MakeFeatureLayer_management(in_feature2,"net_test_lyr.lyr")
    #selecting grid mesh within the buffer range
    if str(oczko)=="rod (XIII) 4,7 m":
        distancebuf=s*4.7
    if str(oczko)=="rod (XIV) 4,32 m":
        distancebuf=s*4.32
    if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
        distancebuf=s*0.626
    if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
        distancebuf=s*0.576
    if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
        distancebuf=s*0.313
    if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
        distancebuf=s*0.288
    if str(oczko)=="fathom 2,134 m":
        distancebuf=s*2.134
    if str(oczko)=="rope (for the rod 4,7 m x 10)":
        distancebuf=s*(10*4.7)
    if str(oczko)=="rope (for the rod 4,32 m x 10)":
        distancebuf=s*(10*4.32)
    else:
        distancebuf=s*t
    arcpy.SelectLayerByLocation_management("net_test_lyr.lyr","WITHIN_A_DISTANCE","buf.shp",distancebuf,"NEW_SELECTION")
    arcpy.CopyFeatures_management("net_test_lyr.lyr",outwarstwa)
    #cleaning up temporary files
    arcpy.Delete_management("buf.shp")
    arcpy.Delete_management("net_test.shp")
    arcpy.Delete_management("net_test_lyr.lyr","lyr")
    arcpy.Delete_management("buf_lyr.lyr","lyr")
    arcpy.Delete_management("zasieg.shp")
    arcpy.Delete_management("zasieg_pkt.shp")
    arcpy.Delete_management("zasieg_tab.dbf")
    arcpy.AddMessage("Wszystko ok")
except:
    arcpy.AddMessage(arcpy.GetMessage())