import arcpy
from math import*
import numpy
import os
try:
    #parameter values
    wsp=arcpy.GetParameterAsText(0)
    outwarstwa=arcpy.GetParameterAsText(1)
    zasieg=arcpy.GetParameter(2)
    oczko=arcpy.GetParameterAsText(3)
    oczko2=arcpy.GetParameter(4)
    mnoznik=arcpy.GetParameter(5)
    s=round(mnoznik,10)
    #workspace
    arcpy.env.overWriteOutput = True
    arcpy.env.workspace=wsp
    #creating a working folder
    out_folder_path=wsp
    out_name="tempnet"
    arcpy.CreateFolder_management(out_folder_path, out_name)
    #unew workspcae
    path=str(os.path.join(wsp, "tempnet"))
    arcpy.env.workspace=path
    #creating a point file from a range file
    arcpy.FeatureVerticesToPoints_management(zasieg,"zasieg_pkt.shp","ALL")
    #adding X and Y fields and coordinates to the layer
    in_features1="zasieg_pkt.shp"
    field_name1="X"
    field_name2="Y"
    arcpy.AddField_management(in_features1, field_name1, "DOUBLE",30,4)
    field_name2="Y"
    arcpy.AddField_management(in_features1, field_name2, "DOUBLE",30,4)
    in_features2="zasieg_pkt.shp"
    expression1="!SHAPE.CENTROID.X!"
    arcpy.CalculateField_management(in_features1, "X", expression1, "PYTHON_9.3")
    expression2="!SHAPE.CENTROID.Y!"
    arcpy.CalculateField_management(in_features1, "Y", expression2, "PYTHON_9.3")
    #create dbf table from layer
    arcpy.CopyRows_management("zasieg_pkt.shp","zasieg_tab.dbf")
    fc = "zasieg_tab.dbf"
    #get values from table to the grid
    where_clause='"OID" = 1'
    rows = arcpy.SearchCursor(fc,where_clause,"","X;Y","")
    for row in rows:
         x1=(row.getValue("X"))
         y1=(row.getValue("Y"))
         a=(str(row.getValue("X")))
         b=(str(row.getValue("Y")))
         c=a+" "+b
    del rows
    fc = "zasieg_tab.dbf"
    where_clause='"OID" = 2'
    rows = arcpy.SearchCursor(fc,where_clause,"","X;Y","")
    for row in rows:
         x2=(row.getValue("X"))
         y2=(row.getValue("Y"))
         d=(str(row.getValue("X")))
         e=(str(row.getValue("Y")))
         f=d+" "+e
    del rows
    fc = "zasieg_tab.dbf"
    where_clause='"OID" = 4'
    rows = arcpy.SearchCursor(fc,where_clause,"","X;Y","")
    for row in rows:
         x3=(row.getValue("X"))
         y3=(row.getValue("Y"))
         g=(str(row.getValue("X")))
         h=(str(row.getValue("Y")))
         k=g+" "+h
    del rows
    distanceh =sqrt((x1 - x2)**2 + (y1 - y2)**2)
    distancew =sqrt((x1 - x3)**2 + (y1 - y3)**2)
    distance1=round(distanceh,0)
    distance2=round(distancew,0)
    #calculation of azimuth and angle 
    deltax1=round((x2-x1),9)
    deltay1=round((y2-y1),9)
    deltax2=round((x3-x1),9)
    deltay2=round((y3-y1),9)
    if deltax1>0 and deltay1>0:
        az1=math.atan(deltay1/deltax1)
    if deltax1<0 and deltay1>0:
        az1=3.141592654+ math.atan(deltay1/deltax1)
    if deltax1<0 and deltay1<0:
        az1=3.141592654+math.atan(deltay1/deltax1)
    if deltax1>0 and deltay1<0:
        az1=6.283185307+math.atan(deltay1/deltax1)
    if deltax2>0 and deltay2>0:
        az2=math.atan(deltay2/deltax2)
    if deltax2<0 and deltay2>0:
        az2=3.141592654+math.atan(deltay2/deltax2)
    if deltax2<0 and deltay2<0:
        az2=3.141592654+math.atan(deltay2/deltax2)
    if deltax2>0 and deltay2<0:
        az2=6.283185307+math.atan(deltay2/deltax2)
    if az2<3.141592654:
        az3=az2+3.141592654
    if az2>=3.141592654:
        az3=az2-3.141592654
    if az1<3.141592654:
        az4=az1+3.141592654
    if az1>=3.141592654:
        az4=az1-3.141592654
    #determining sin and cos azimuth
    az1c=round(math.cos(az1),9)
    az1s=round(math.sin(az1),9)
    az2c=round(math.cos(az2),9)
    az2s=round(math.sin(az2),9)
    az3c=round(math.cos(az3),9)
    az3s=round(math.sin(az3),9)
    az4c=round(math.cos(az4),9)
    az4s=round(math.sin(az4),9)
    #calculating the angle alpha 
    alfa=az1-az2
    #change of range from the polygon to points 
    in_fm="zasieg_pkt.shp"
    out_fm="zasieg_pkt_move.shp"
    arcpy.Copy_management(in_fm,out_fm)
    if str(oczko)=="rod (XIII) 4,7 m":
        tm=s*4.70
    if str(oczko)=="rod (XIV) 4,32 m":
        tm=s*4.32
    if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
        tm=s*0.626
    if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
        tm=s*0.576
    if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
        tm=s*0.313
    if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
        tm=s*0.288
    if str(oczko)=="fathom 2,134 m":
        tm=s*2.134
    if str(oczko)=="rope (for the rod 4,7 m x 10)":
        tm=s*(10*4.7)
    if str(oczko)=="rope (for the rod 4,32 m x 10)":
        tm=s*(10*4.32)
    if str(oczko)=="none":
        tm=s*oczko2
    #move points horizontally 
    where_clause='"FID" = 1'
    xOffsetm=-tm*az2c 
    yOffsetm=-tm*az2s 
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 2'
    xOffsetm=tm*az3c
    yOffsetm=tm*az3s
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 3'
    xOffsetm=0
    yOffsetm=0
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 4'
    xOffsetm=-tm*az3c
    yOffsetm=-tm*az3s
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 0'
    xOffsetm=-tm*az3c
    yOffsetm=-tm*az3s
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    #moving the point vertically 
    where_clause='"FID" = 1'
    xOffsetm=-tm*az1c 
    yOffsetm=-tm*az1s
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 2'
    xOffsetm=tm*az1c
    yOffsetm=tm*az1s
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 3'
    xOffsetm=0
    yOffsetm=0
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 4'
    xOffsetm=-tm*az1c
    yOffsetm=-tm*az1s
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    where_clause='"FID" = 0'
    xOffsetm=-tm*az1c
    yOffsetm=-tm*az1s
    cursor=arcpy.da.UpdateCursor(out_fm,["SHAPE@TRUECENTROID"],where_clause)
    for row in cursor:
        cursor.updateRow([[row[0][0] + xOffsetm,row[0][1] + yOffsetm]])
    del cursor
    #creating duplicate and shifted horizontal and vertical lines from a range file 
    inFeatureClass="zasieg_pkt_move.shp"
    layer="zasieg_pkt_move_lyr.lyr"
    outFeatureClass="pkt_pion.shp"
    outFeatureClass1="pkt_poz.shp"
    outFeatureClass2="linia_pion.shp"
    outFeatureClass3="linia_poz.shp"
    arcpy.MakeFeatureLayer_management(inFeatureClass,layer)
    arcpy.SelectLayerByAttribute_management (layer, "NEW_SELECTION", "FID=1 OR FID=2")
    arcpy.CopyFeatures_management(layer,outFeatureClass)
    arcpy.SelectLayerByAttribute_management (layer, "NEW_SELECTION", "FID=1 OR FID=4")
    arcpy.CopyFeatures_management(layer,outFeatureClass1)
    arcpy.PointsToLine_management(outFeatureClass, outFeatureClass2)
    arcpy.PointsToLine_management(outFeatureClass1, outFeatureClass3)
    arcpy.Delete_management(inFeatureClass)
    arcpy.Delete_management(outFeatureClass)
    arcpy.Delete_management(outFeatureClass1)
    arcpy.Delete_management(layer)
    arcpy.Delete_management("in_memory")
    #copying and moving vertical line
    fcl="linia_pion.shp"
    if str(oczko)=="rod (XIII) 4,7 m":
        t=4.7
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="rod (XIV) 4,32 m":
        t=4.32
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
        t=0.626
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
        t=0.576
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
        t=0.313
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
        t=0.288
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="fathom 2,134 m":
        t=2.134
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="rope (for the rod 4,7 m x 10)":
        t=(10*4.7)
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="rope (for the rod 4,32 m x 10)":
        t=(10*4.32)
        ilo = distance2/(t*s)
        z=round(ilo,0)
    if str(oczko)=="none":
        t=oczko2
        ilo = distance2/(t*s)
        z=round(ilo,0)
    print str("z="),z
    dd=range(1,int(z)+1)
    for i in dd:
        in_f=fcl
        out_f="pn"+str(i)+".shp"
        arcpy.Copy_management(in_f,out_f)
        mnoz=i
        if str(oczko)=="rod (XIII) 4,7 m":
            t1=(s*4.7)*az2c
            t5=(s*4.7)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="rod (XIV) 4,32 m":
            t1=(s*4.32)*az2c
            t5=(s*4.32)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
            t1=(s*0.626)*az2c
            t5=(s*0.626)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
            t1=(s*0.576)*az2c
            t5=(s*0.576)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
            t1=(s*0.313)*az2c
            t5=(s*0.313)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
            t1=(s*0.288)*az2c
            t5=(s*0.288)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="fathom 2,134 m":
            t1=(s*2.134)*az2c
            t5=(s*2.134)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="rope (for the rod 4,7 m x 10)":
            t1=(s*(10*4.7))*az2c
            t5=(s*(10*4.7))*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="rope (for the rod 4,32 m x 10)":
            t1=(s*(10*4.32))*az2c
            t5=(s*(10*4.32))*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        if str(oczko)=="none":
            t1=(s*oczko2)*az2c
            t5=(s*oczko2)*az2s
            xOffset = t1*mnoz
            yOffset = t5*mnoz
        with arcpy.da.UpdateCursor(out_f, ["SHAPE@TRUECENTROID"]) as cursor:
                for row in cursor:
                    cursor.updateRow([[row[0][0] + xOffset,row[0][1] + yOffset]])
        del cursor
    #copying and moving the horizontal line 
    fcl1="linia_poz.shp"
    if str(oczko)=="rod (XIII) 4,7 m":
        t2=4.7
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="rod (XIV) 4,32 m":
        t2=4.32
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
        t2=0.626
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
        t2=0.576
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
        t2=0.313
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
        t2=0.288
        ilo2 = distance1/(t2*s)
        z2=round1(ilo,0)
    if str(oczko)=="fathom 2,134 m":
        t2=2.134
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="rope (for the rod 4,7 m x 10)":
        t2=(10*4.7)
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="rope (for the rod 4,32 m x 10)":
        t2=(10*4.32)
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    if str(oczko)=="none":
        t2=oczko2
        ilo2 = distance1/(t2*s)
        z2=round(ilo2,0)
    print str("z2="),z2
    dd1=range(1,int(z2)+1)
    for i in dd1:
        in_f1=fcl1
        out_f1="pz"+str(i)+".shp"
        arcpy.Copy_management(in_f1,out_f1)
        mnoz1=i
        if str(oczko)=="rod (XIII) 4,7 m":
            t3=((s*4.7)*az1s)
            t4=(s*4.7)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="rod (XIV) 4,32 m":
            t3=((s*4.32)*az1s)
            t4=(s*4.32)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="ell (forthe rod 4,7 m) 0,626 m":
            t3=((s*0.626)*az1s)
            t4=(s*0.626)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="ell (forthe rod 4,32 m) 0,576 m":
            t3=((s*0.576)*az1s)
            t4=(s*0.576)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="foot (for the rod 4,7 m) 0,313 m":
            t3=((s*0.313)*az1s)
            t4=(s*0.313)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="foot (for the rod 4,32 m) 0,288 m":
            t3=((s*0.288)*az1s)
            t4=(s*0.288)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="fathom 2,134 m":
            t3=((s*2.134)*az1s)
            t4=(s*2.134)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="rope (for the rod 4,7 m x 10)":
            t3=((s*(10*4.7))*az1s)
            t4=(s*(10*4.7))*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = s*t3*mnoz
        if str(oczko)=="rope (for the rod 4,32 m x 10)":
            t3=((s*(10*4.32))*az1s)
            t4=(s*(10*4.32))*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        if str(oczko)=="none":
            t3=((s*oczko2)*az1s)
            t4=(s*oczko2)*az1c
            xOffset1 = t4*mnoz1
            yOffset1 = t3*mnoz1
        with arcpy.da.UpdateCursor(out_f1, ["SHAPE@TRUECENTROID"]) as cursor:
            for row in cursor:
                cursor.updateRow([[row[0][0] + xOffset1,row[0][1] + yOffset1]])
        del cursor
    #cleaning up working files 
    arcpy.Delete_management("buf.shp")
    arcpy.Delete_management("net_test.shp")
    arcpy.Delete_management("net_test_lyr.lyr","lyr")
    arcpy.Delete_management("buf_lyr.lyr","lyr")
    arcpy.Delete_management("zasieg.shp")
    arcpy.Delete_management("zasieg_pkt.shp")
    arcpy.Delete_management("zasieg_tab.dbf")
    arcpy.Delete_management("in_memory")
    #creating a list of files 
    lista=arcpy.ListFeatureClasses()
    all_line=str(os.path.join(path,"siatka_linii.shp"))
    #creating file from all lines
    arcpy.Merge_management(lista,all_line)
    #return to the original workspace 
    arcpy.env.workspace=wsp
    siatka="siatkal.shp"
    layer1="siatka1.lyr"
    #convert shp file with lines to polygon
    arcpy.FeatureToPolygon_management(all_line,siatka)
    #creating a layer from the polygon 
    arcpy.MakeFeatureLayer_management(siatka,layer1)
    #selection of grid meshes that have centroids within the range 
    arcpy.SelectLayerByLocation_management(layer1,"HAVE_THEIR_CENTER_IN",zasieg)
    #creating a layer with selected polygons and saving it to the output file 
    arcpy.CopyFeatures_management(layer1,outwarstwa)
    #cleaning up 
    arcpy.Delete_management(layer1)
    arcpy.Delete_management(all_line)
    arcpy.Delete_management(siatka)
    arcpy.Delete_management("in_memory")
    for v in lista:
        arcpy.Delete_management(v)
    #delete temporary folder 
    arcpy.Delete_management("in_memory")
    arcpy.Delete_management("tempnet")
except:
    arcpy.AddMessage(arcpy.GetMessage())